/*
 *      L I S T _ D e q u e u e
 *
 *  This function is called when it is required
 *  to remove a node from the start of a list.
 *
 *
 * (c) Copyright 1996-1997 David J. Walker
 *     Email:  d.j.walker@x400.icl.co.uk
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  22 May 96   DJW   - First version
 */


#include <liblist.h>
#include "liblistx.h"


node_t  LIST_Dequeue (list_t list)
{
    _listmaster_t listmaster;
    node_t  node;

    LIBDEBUG ("LIST_Dequeue", \
           "'list' parameter is not a valid list instance", \
           _LIST_ListCheck(list))

    listmaster = list->listclass->master;

    node = listmaster->first(list);
	if (node != NULL)
	{
#ifdef LIBTEST
        LIBASSERT(listmaster->remove(list, _LIST_REALNODE(list,node)) == 0);
#else
        (void) listmaster->remove(list, _LIST_REALNODE(list,node));
#endif /* LIBTEST */
	}
    return (node);
}

