/*
 *          _ L I S T _ F i f o A f t e r
 *
 *  This routine adds a node on a list that
 *  DOES maintain a pointer to the last node
 *
 *
 * (c) Copyright 1996-1997 David J. Walker
 *     Email:  d.j.walker@x400.icl.co.uk
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  23 May 96   DJW   - First version
 *
 *  28 May 96   DJW   - Updated 'remove' to allow for the user providing
 *                      a node to remove who that not on the list!
 */


#include <liblist.h>
#include "liblistx.h"


int     _LIST_FifoAfter (list_t list, node_t newnode, node_t oldnode)
{
	register _fifoh_t fifolist = (_fifoh_t)list;
    int     reply;

    reply = _LIST_LifoAfter(list, newnode, oldnode);
    if (fifolist->last == NULL  || fifolist->last == (_fifo_t)oldnode)
    {
        fifolist->last = (_fifo_t)newnode;
    }
    return (reply);
}

