/*
 *      L I S T _ O r d e r e d
 *
 *  This function is called when it is required
 *  to find out if a list is ordered.
 *
 *
 *  Returns:
 *      0       No
 *      <>0     Yes
 *
 *
 * (c) Copyright 1996-1997 David J. Walker
 *     Email:  d.j.walker@x400.icl.co.uk
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  18 May 96   DJW   - First version
 */


#include <liblist.h>
#include "liblistx.h"


int     LIST_Ordered (list_t list)
{
    register listclass_t listclass;

    LIBDEBUG ("LIST_Ordered", \
           "'list' parameter is not a valid list instance", \
           _LIST_ListCheck(list))

#if 0
	if (LIST_Embedded(list))
	{
		
	}
#endif

    listclass = list->listclass;

    switch (listclass->master->listtype)
    {
        case LIST_TYPE_HASH:
                return LIST_ORDER_NA;
        default:
                return  (listclass->compare != NULL ? LIST_ORDERED : LIST_UNORDERED);
    }
}

